function CH_MainMenuFolder(){
}

CH_MainMenuFolder.onInit = function() {
    if((view.showGamesFolder != null) && (view.showGamesFolder == "true"))
    {
        topFolders = mainmenu.ALL;
        for(i = 0; i < 10;i++)
        {
          if(topFolders[i].uid == "b18dbbd2-503a-4442-9308-5575ee38c210")
          {
              break;
          }
        }
        mmFolders = topFolders[i].ALL;
        for(i = 0; i < 10;i++)
        {
          if(mmFolders[i].uid == "67dc1191-2928-4938-abce-1a73cb5ce490")
          {
              break;
          }
        }
        flow.folder = mmFolders[i]; 
        player.foreground();
    }
    view.focusedItem = view.tags.ListForm.MainMenuFolder.data[0];
}

CH_MainMenuFolder.onShow = function() {
	flow.ttsEnabled = uisounds.isTTSEnabled();

	// If the folder is dirty (say a MIDlet was installed added), then
	// we'll need to update the folder.	
	if (flow.folder.dirty) {
	    flow.folder.refresh();
	    view.tags.ListForm.MainMenuFolder.reload();
	}
	// the internal values of the focused node may need 
	// to be updated like the java Id of a MIDLet (Move To Phone, Move To Card, etc.)
	
	view.tags.ListForm.refresh();

	//view.tags.ListForm.EmptyList.refresh();
	//view.tags.ListForm.MainMenuFolder.refresh();
	//view.tags.ListForm.MainMenuFolder.focusedItem.refresh();

	this.setMenuVisibility(view.tags.ListForm.MainMenuFolder.focusedItem);
}

CH_MainMenuFolder.onLongFocus = function(appNode) {
    // readout TTS
	if (flow.ttsEnabled) {
		uisounds.tts(appNode.appName);
	}

	this.setMenuVisibility(appNode);
}

CH_MainMenuFolder.setMenuVisibility = function(appNode) {
	var reorderVis = this.isReorderVisible();
	var manageVis = this.isManageVisible(appNode) == "true";
	var sendToVis = this.isSendToVisible(appNode) == "true";
	var invisNetVis = this.isInvisibleLinkVisible(appNode) == "true";

    	//Reorder menu item visibility
    	document.getElementById("reorder").visible = (reorderVis ? "true" : "false"); 
	document.getElementById("manage").visible = (manageVis ? "true" : "false");
	document.getElementById("sendto").visible = (sendToVis ? "true" : "false");
	document.getElementById("movetofolder").visible = this.isUserInstalled(appNode);
	document.getElementById("movetomemcard").visible = this.isMoveToMemoryCardVisible(appNode);
	document.getElementById("movetophone").visible = this.isMoveToPhoneVisible(appNode);
	document.getElementById("movetomsim").visible = this.isMoveToMSIMVisible(appNode);
        document.getElementById("checkforupdates").visible = (appNode && appNode.updatable ? "true" : "false");
	document.getElementById("deleteapp").visible = this.isUserInstalled(appNode);
        document.getElementById("deleteapp").enabled =  (!appNode || appNode.protectedFromDeletion ? "false" : "true");
	document.getElementById("copytomemcard").visible = this.isCopyToMemoryCardVisible(appNode);
	document.getElementById("invisible").visible = (invisNetVis ? "true" : "false");

	// disable the left softkey if no options are available (avoid unecessary refreshing of softkeys)
	var enable = (reorderVis || manageVis || sendToVis || invisNetVis);
	var options = document.getElementById("options");
	if (options.enabled == null || enable != (options.enabled == "true")) {
		options.enabled = (enable ? "true" : "false");
		view.tags.refreshSoftkeys();
	}
}

CH_MainMenuFolder.getAppType = function(appNode) {
	// level 1->2 folder navigation 
	if (appNode.folder) {
		if (appNode == flow.folder) {
			return "";
		}

		flow.folderNavLevel = flow.folderNavLevel + 1;
		flow.folder = appNode;
		return "folder";
	}
	// launch app
	if(appNode.java)
		appNode.launchJavaSplashScreen();
	return "native";
}

CH_MainMenuFolder.folderNavUp = function() {
        if((view.showGamesFolder != null) && (view.showGamesFolder == "true"))
        {
            view.showGamesFolder = "false";
            player.rewind();
            player.hide();
        }
	if (flow.folderNavLevel >= 2) { // naving up from 2->1
		flow.folder = flow.folderLevel1;
	} else if (flow.folderNavLevel == 1) {// naving up from 1->0
		flow.folder = flow.folderLevel1 = null;
	}
	flow.folderNavLevel = flow.folderNavLevel - 1;
}

CH_MainMenuFolder.setupSendToMessage = function(appNode) {
	flow.infoMessageTitle = i18n.translate('TXT_RID_HEADER_LICENSE_RESTRICTION', 'License Restriction');
	flow.infoMessage = i18n.translate('FMT_RID_INSTRUCTIONALTXT_BECAUSE_OF_LICENSE_RESTRICTIONS_THE_URL_TO_DOWNLOAD_1_WILL_BE_SENT_RATHER_THAN_THE_APPLICATION', 
					'Because of license restrictions the URL to download %1 will be sent, rather than the application.').arg(appNode.appName);
	flow.infoSuccessLaunchUri = "native://mainmenu/ui.CopyToMessage";
	flow.infoSuccessLaunchUid = appNode.uid;
	if (!appNode.hasUrl) {
		//url does not exist, get ready for error
		flow.infoFailureMessage = i18n.translate('TXT_RID_INSTRUCTIONALTXT_URL_NOT_RETRIEVED_MESSAGE_NOT_SENT', 'The URL could not be retrieved.  Your message was not sent.  Please try again.');
	} else {
		//reset in case it was set previously 
	    flow.infoFailureMessage = null;
	}
}

CH_MainMenuFolder.setupSendToEmail = function(appNode) {
	flow.infoMessageTitle = i18n.translate('TXT_RID_HEADER_LICENSE_RESTRICTION', 'License Restriction');
	flow.infoMessage = i18n.translate('FMT_RID_INSTRUCTIONALTXT_BECAUSE_OF_LICENSE_RESTRICTIONS_THE_URL_TO_DOWNLOAD_1_WILL_BE_SENT_RATHER_THAN_THE_APPLICATION', 
					'Because of license restrictions the URL to download %1 will be sent, rather than the application.').arg(appNode.appName);
	flow.infoSuccessLaunchUri = "native://mainmenu/ui.CopyToEmail";
	flow.infoSuccessLaunchUid = appNode.uid;
	if (!appNode.hasUrl) {
		//url does not exist, get ready for error
		flow.infoFailureMessage = i18n.translate('TXT_RID_INSTRUCTIONALTXT_URL_NOT_RETRIEVED_EMAIL_NOT_SENT', 'The URL could not be retrieved.  Your email was not sent.  Please try again.');
	} else {
		//reset in case it was set previously
	    flow.infoFailureMessage = null;
	}
}

CH_MainMenuFolder.setupSendToBluetooth = function(appNode) {
	flow.infoMessageTitle = i18n.translate('TXT_RID_HEADER_LICENSE_RESTRICTION', 'License Restriction');
	flow.infoMessage = i18n.translate('FMT_RID_INSTRUCTIONALTXT_BECAUSE_OF_LICENSE_RESTRICTIONS_THE_URL_TO_DOWNLOAD_1_WILL_BE_SENT_RATHER_THAN_THE_APPLICATION', 
					'Because of license restrictions the URL to download %1 will be sent, rather than the application.').arg(appNode.appName);
	flow.infoSuccessLaunchUri = "native://mainmenu/ui.CopyToBluetooth";
	flow.infoSuccessLaunchUid = appNode.uid;
	if (!appNode.hasUrl) {
		//url does not exist, get ready for error
		flow.infoFailureMessage = i18n.translate('TXT_RID_HEADER_CANNOT_SEND', 'Cannot Send');
	} else {
		//reset in case it was set previously
	    flow.infoFailureMessage = null;
	}
}

CH_MainMenuFolder.setupLaunchSendToX = function() {
	var target = document.getElementById("launchHREF");
	if (!flow.infoFailureMessage) {
		target.uri = flow.infoSuccessLaunchUri;
	} else {
		target.uri = "view:flows/mainmenu/notice/error_msg.xml";
		flow.errorMessageTitle = i18n.translate('TXT_RID_HEADER_SEND_FAILED', 'Send Failed');
		flow.errorMessage = flow.infoFailureMessage;
		flow.infoFailureMessage = null;
	}	
	view.backOnActivate = true;
}

CH_MainMenuFolder.confirm = function(appNode, header, msg, action) {
    flow.selectedApp = appNode;
    flow.confirmHeader = header;
    flow.confirmMsg = msg;
    flow.confirmDoAction = action;
}

CH_MainMenuFolder.copyToMemoryCard = function(appNode) {

	var target = document.getElementById("targetHREF");

	if (mainmenu.cardPresent) {
		if (!appNode.sendToCard()) {
			flow.errorMessageTitle = i18n.translate('TXT_RID_HEADER_SEND_FAILED', 'Send Failed');
			flow.errorMessage = i18n.translate('TXT_RID_INSTRUCTIONALTXT_THE_APPLICATION_WAS_NOT_ABLE_TO_BE_SENT_THE_RECEIVING_DEVICE_DOES_NOT_ACCEPT_FORWARDED_APPLICATIONS', 
											   'The application was not able to be sent. The receiving device does not accept forwarded applications.');
			target.uri = "view:flows/mainmenu/notice/error_msg.xml";
		} else {
			flow.infoMessage = i18n.translate('TXT_RID_INSTRUCTIONALTXT_THE_SELECTED_APPLICATION_WAS_SUCCESSFULLY_COPIED', 
											  'The selected application was successfully sent.');
			target.uri = "view:flows/mainmenu/notice/info_msg.xml"; 
		}
	} else {
		// This operation only works if a memory card is present!!!
		target.uri = "";
	}
}

CH_MainMenuFolder.getInvLabel = function(appNode) {
    return appNode.getInvLabel();
}

CH_MainMenuFolder.getInvURL = function(appNode) {
    return appNode.getInvURL();
}

// *************************************************************************
// ********************* Menu/Widget Visibility ****************************
// *************************************************************************
CH_MainMenuFolder.isReorderVisible = function() {
    // Reorder option only if more than one item is present
    return flow.folder.ALL.length > 1;
}

CH_MainMenuFolder.isNonEmptyFolder = function() {
	return flow.folder.ALL.length > 0;
}

CH_MainMenuFolder.isMoveToMSIMVisible = function(appNode) {
	if (!mainmenu.msimPresent)
		return "false";
	return (this.isUserInstalled(appNode) == "true" 
	&& this.isInstalledOnPhone(appNode)) ? "true" : "false";
}

CH_MainMenuFolder.isMoveToMemoryCardVisible = function(appNode) {
	if (!mainmenu.cardPresent)
		return "false";
	return (this.isUserInstalled(appNode) == "true" 
	&& this.isInstalledOnPhone(appNode)) ? "true" : "false";
}

CH_MainMenuFolder.isMoveToPhoneVisible = function(appNode) {
	if (this.isUserInstalled(appNode) == "false")
		return "false";
	if (mainmenu.cardPresent && this.isInstalledOnMemoryCard(appNode) ||
		mainmenu.msimPresent && this.isInstalledOnMSIM(appNode))
		return "true";
	return "false";
}

CH_MainMenuFolder.isCopyToMemoryCardVisible = function(appNode) {
	if (!mainmenu.cardPresent || this.isUserInstalled(appNode) == "false")
		return "false";
	return ((this.isInstalledOnPhone(appNode) 
			||this. isInstalledOnMSIM(appNode)) 
		&& !appNode.installerOnMemoryCard) ? "true" : "false";
}

CH_MainMenuFolder.isInvisibleLinkVisible = function(appNode) {
	    return (appNode && appNode.invVisible)? "true" : "false";
}

CH_MainMenuFolder.isSendToVisible = function(appNode) {
	if (this.isNonEmptyFolder())
		return this.isUserInstalled(appNode);
    else
        return "false";
}

CH_MainMenuFolder.isManageVisible = function(appNode) {
	if (this.isNonEmptyFolder())
    	return (appNode.java ? "true" : "false");
    else
        return "false";
}

CH_MainMenuFolder.isUserInstalled = function(appNode) {
		return (appNode && ( appNode.userInstalledJava || appNode.userInstalledQtApp )) ? "true" : "false";
}

// *************************************************************************
// ************************** Helpers **************************************
// *************************************************************************

CH_MainMenuFolder.isInstalledOnPhone = function(appNode) {
	return appNode.getDevice() == "Phone";
}

CH_MainMenuFolder.isInstalledOnMemoryCard = function(appNode) {
	return appNode.getDevice() == "Memory Card";
}

CH_MainMenuFolder.isInstalledOnMSIM = function(appNode) {
	return appNode.getDevice() == "MegaSIM";
}

CH_MainMenuFolder.getMoveToMSIMString = function() {	
	return i18n.translate('TXT_RID_HEADER_MOVE_TO', 'Move To') + " " + settings.getValueFromDMTree("./DevDetail/Ext/Conf/MegaSIM/MegaSIMName");
}

// refreshing MainMenuList after preloaded midlet app gets added - LIBoo73432
CH_MainMenuFolder.signalAppAdded = function() {

	flow.folder.refresh();
	view.tags.MainMenuFolder.reload();
	view.tags.MainMenuFolder.focusedItem.refresh();
	this.setMenuVisibility(view.tags.MainMenuFolder.focusedItem);

}
