
function CH_MainMenu(){
}

CH_MainMenu.setDisplayFirstItem = function() {
    flow.isDisplayFirstItem = 1;
}

CH_MainMenu.onInit = function() {
	var viewType = mainmenu.view;
	
	// if it is verified that listview has been chosen, then display the main menu
	// in list view	
	if ( viewType == "list" ) {
		CH_MainMenu.onListSelect();
	} else if ( viewType == "spinner" ) {
		CH_MainMenu.onSpinnerSelect();
	} else {
		CH_MainMenu.onGridSelect();
	}

	CH_MainMenu.resetFocusedItem();

	// set initial visibility
	document.getElementById("manage").visible = (view.focusedItem.java ? "true" : "false");	
	document.getElementById("checkupdates").visible = (view.focusedItem.updatable ? "true" : "false");
}

// Overwrite defaultEvents.endKey
defaultEvents.endKey = function() {
    flow.isDisplayFirstItem = 1;
    player.rewind();
    player.background();
}

CH_MainMenu.onFini = function() {
    if (player != null) {
        flow.isDisplayFirstItem = 1;//Deepak LIBoo40383
        player.rewind();
        player.background();
    }
}

CH_MainMenu.resetFocusedItem = function() {
	var index = mainmenu.getDefaultFocusItem;
	view.focusedItem = view.tags.MainMenuList.data[index];
	view.tags.MainMenuList.focusedIndex = index;
}

CH_MainMenu.onShow = function() {
	flow.ttsEnabled = uisounds.isTTSEnabled();
	var mainmenudirty = mainmenu.dirty;
	if (mainmenudirty) {
	  mainmenu.refresh();
	}	

    if (flow.isDisplayFirstItem) {
		CH_MainMenu.resetFocusedItem();
	    view.tags.MainMenuList.reload();
		flow.isDisplayFirstItem = 0;
    }
	else if (mainmenudirty) {
        var i = view.tags.MainMenuList.focusedIndex;
		view.tags.MainMenuList.reload();
        view.tags.MainMenuList.focusedIndex = i;
	}
	flow.folderNavLevel = 0;
}

CH_MainMenu.onLongFocus = function(appNode) {	
    // readout TTS
	if (flow.ttsEnabled) {
		uisounds.tts(appNode.appName);
	}
	
	document.getElementById("manage").visible = (appNode.java ? "true" : "false");
	document.getElementById("checkupdates").visible = (appNode.updatable ? "true" : "false");
}

CH_MainMenu.onGridSelect = function() {
	mainmenu.view = "grid";
	mainmenu.refresh();
	var focusedIndex = view.tags.MainMenuList.focusedIndex;
	view.tags.MainMenuList['class'] = 'gridclass';
	view.tags.MainMenuList.focusedIndex = focusedIndex;
        view.gridcheck = "true";
        view.listcheck = "false";
        view.spinnercheck = "false";
}

CH_MainMenu.onListSelect = function() {
	mainmenu.view = "list";
        mainmenu.refresh();
	var focusedIndex = view.tags.MainMenuList.focusedIndex;
	view.tags.MainMenuList['class'] = 'listclass';
	view.tags.MainMenuList.focusedIndex = focusedIndex;
        view.gridcheck = "false";
        view.listcheck = "true";
        view.spinnercheck = "false";
}

CH_MainMenu.onSpinnerSelect = function() {
	mainmenu.view = "spinner";
        mainmenu.refresh();
	var focusedIndex = view.tags.MainMenuList.focusedIndex;
	view.tags.MainMenuList['class'] = 'spinnerclass';
	view.tags.MainMenuList.focusedIndex = focusedIndex;   
        view.gridcheck = "false";
        view.listcheck = "false";
        view.spinnercheck = "true";
}

CH_MainMenu.getAppType = function(appNode) {
	if (appNode.folder) {
		flow.folderNavLevel = 1;
		flow.folder = flow.folderLevel1 = appNode;
		return "folder";
	}
	// launch app
	if(appNode.java)
		appNode.launchJavaSplashScreen();
	return "native";
}

// Main Menu has been updated; it is generated from signalCardPlugged
CH_MainMenu.signalCardPlugged = function() {
    mainmenu.refresh();
	flow.folder.refresh();
	view.tags.ListForm.MainMenuFolder.reload();
}

// Main Menu has been updated; it is generated from signalCardUnplugged
CH_MainMenu.signalCardUnplugged = function() {
    mainmenu.refresh();
	flow.folder.refresh();
	view.tags.ListForm.MainMenuFolder.reload();
}

// refreshing MainMenuList after preloaded midlet app gets added - LIBoo73432
CH_MainMenu.signalAppAdded = function() {
    mainmenu.refresh();
    view.tags.MainMenuList.reload();
}


//---------- XM repeatable events -----------
// Don't need to override, the default handlers defined in flowdefaults.js will be called
